#include <fstream>
#include <iostream>
#include <iomanip>
#include "ko/PhysicalDOMTranslator.hpp"

using namespace Behavior;
using namespace std;

int main(int argC, char* argV[])
{
  if(argC > 1)
    {
      Physical p;
      PhysicalDOMTranslator t;

      t.parse(argV[1], p);

      cerr << "parse went ok" << endl;
      cerr << "elements: " << p.elements.size() << endl;
      cerr << "connections: " << p.connections.size() << endl;

      if(argC > 2)
	{
	  cerr << "hello" << endl;

	  ofstream os;
	  os.open(argV[2], ios::out);

	  t.write(os, p);
	}
      else
	{
	  t.write(cout, p);
	}
    }

  return 0;
}


