#include "ko/MountedPoint.hpp"
//#include <Inventor/SbLinear.h>


namespace ko
{

MountedPoint::MountedPoint() : origo(0), xBase(0), yBase(0), zBase(0),
			       target(0), original(3),
			       orthoXBase(3), orthoYBase(3), orthoZBase(3)
{
}

void MountedPoint::calculateBasis()
{
  /*
  // Orthogonalize the basis (Gram-Schmidt)

  add(*xBase, scaled(*origo, -1), orthoXBase);

  add(*yBase, scaled(*origo, -1), orthoYBase);
  add(orthoYBase,
      scaled(orthoXBase,
	     -dot(orthoYBase, orthoXBase) / dot(orthoXBase, orthoXBase)),
      orthoYBase);

  add(*zBase, scaled(*origo, -1), orthoZBase);
  add(orthoZBase,
      scaled(orthoXBase,
	     -dot(orthoZBase, orthoXBase) / dot(orthoXBase, orthoXBase)),
      orthoZBase);
  add(orthoZBase,
      scaled(orthoYBase,
	     -dot(orthoZBase, orthoYBase) / dot(orthoYBase, orthoYBase)),
      orthoZBase);
  */
}

void MountedPoint::calculatePosition()
{
  /*
  // Calculate transformed position of original

  mtl::copy(*origo, *target);
  add(*target, scaled(orthoXBase, original(0)), *target);
  add(*target, scaled(orthoYBase, original(1)), *target);
  add(*target, scaled(orthoZBase, original(2)), *target);
  */
}

void MountedPoint::mount(Vector &p)
{
  /*

  // We assume origo and the bases are valid

  calculateBasis();

  // Express mountingPoint in the new vector space

  Vector mountingPoint(3), temp(3);

  add(p, scaled(*origo, -1), mountingPoint);

  mtl::copy(scaled(orthoXBase,
		   dot(mountingPoint, orthoXBase) /
		   dot(orthoXBase, orthoXBase)), temp);

  original(0) = two_norm(temp) / two_norm(orthoXBase);

  if(dot(temp, orthoXBase) < 0)
  {
    original(0) *= -1;
  }


  mtl::copy(scaled(orthoYBase,
		   dot(mountingPoint, orthoYBase) /
		   dot(orthoYBase, orthoYBase)), temp);

  original(1) = two_norm(temp) / two_norm(orthoYBase);

  if(dot(temp, orthoYBase) < 0)
  {
    original(1) *= -1;
  }


  mtl::copy(scaled(orthoZBase,
		   dot(mountingPoint, orthoZBase) /
		   dot(orthoZBase, orthoZBase)), temp);

  original(2) = two_norm(temp) / two_norm(orthoZBase);

  if(dot(temp, orthoZBase) < 0)
  {
    original(2) *= -1;
  }
  */
}




}
