#if !defined(CONNECTION_HPP)
#define CONNECTION_HPP

#include <string>
#include "ko/Element.hpp"

namespace ko
{

struct Connection
{
  Element *element1, *element2;

  bool transient;
  double length;

  double damage;
  double tension;
  double tension0;

  Connection() : element1(0), element2(0), transient(false), length(1),
		 damage(1), tension(0), tension0(0)
	       
  {
  }

  void connect(Element &e1, Element &e2);
  void disconnect();
};

void print(Connection &);

}

#endif // CONNECTION_HPP
