#if !defined(MOUNTEDPOINT_HPP)
#define MOUNTEDPOINT_HPP

#include <list>
#include <map>
#include "ko/LinAlg.hpp"

namespace ko
{

class MountedPoint
{
public:
  Vector *origo, *xBase, *yBase, *zBase;
  Vector *target, original;
  Vector orthoXBase, orthoYBase, orthoZBase;

  MountedPoint();
  void calculatePosition();
  void calculateBasis();

  void mount(Vector &p);
  //void findBasis(Element &mounter, Element &mountee);
};

}

#endif // MOUNTEDPOINT_HPP

