#if !defined(PHYSICALWATCHER_HPP)
#define PHYSICALWATCHER_HPP

#include "ko/Element.hpp"
#include "ko/Connection.hpp"

namespace ko
{

class PhysicalWatcher
{
public:
  virtual void elementAdded(Element &e) = 0;
  virtual void elementRemoved(Element &e) = 0;

  virtual void connectionAdded(Connection &c) = 0;
  virtual void connectionRemoved(Connection &c) = 0;
};

}

#endif // PHYSICALWATCHER_HPP
