#if !defined(MATERIAL_HPP)
#define MATERIAL_HPP

#include <string>
#include "ko/LinAlg.hpp"

namespace ko
{

struct Material
{
  double young;
  double damp;
  double friction;
  double density;
  double plasticity;
  double strength;
  double collisionStrength;

  std::string name;

  Material();
};

}

#endif // MATERIAL_HPP
